--Name: FarmingTablet
--Author: kevink98
--Date: 17.04.2016
--Version: 0.1.1

--Versionen: nothing
	
--Keine Änderung ohne meine Erlaubnis!
--No modification without my permission!

FarmingTablet = {};
FarmingTablet_directory = g_currentModDirectory;
FarmingTablet_directoryMods = g_modsDirectory;

addModEventListener(FarmingTablet);

print("FarmingTablet v0.1 loaded! Support on Marhu.net");
--g_currentMission.environment.currentDay

function FarmingTablet:loadMap ()
	--local currentTime = g_currentMission.environment.dayTime;
	
	self.posDebug = false;
	self.version = 0.1;
	--load
	
	dedi = false;
		
		
	self.start = true; --Startbildschirm--
	
	--App-Klickzonen--
	FarmingTablet.kz = {};
	FarmingTablet.kz.app1 = false; -- Bank--
	FarmingTablet.kz.app2 = false; -- FabrikscriptExtension--
	FarmingTablet.kz.app3 = false; -- SoilExtension--
	
	local path = getUserProfileAppPath();	
	self.savegameIndex = g_currentMission.missionInfo.savegameIndex;
	local file = path.."/FarmingTabletSavegame"..tostring(self.savegameIndex)..".xml";
	local Xml;
	if fileExists(file) then
		Xml = loadXMLFile("FarmingTablet_XML", file, "farmingTablet");	
		print("Load XML-File for FarmingTablet!");		
	else
		Xml = createXMLFile("FarmingTablet_XML", file, "farmingTablet");
		saveXMLFile(Xml);
		print("Create XML-File for FarmingTablet!");
	end;		
	self:loadOverlay();
	self:loadScripts();
	self:registerScripts ();
	FarmingTablet.version = false;
end;


function FarmingTablet:loadOverlay () 
	self.overlay = {};
	self.overlay.tablet = createImageOverlay(FarmingTablet_directory.."huds/tablet.dds");
	self.overlay.backScreen = createImageOverlay(FarmingTablet_directory.."huds/backScreen.dds");
	self.overlay.pfeilL = createImageOverlay(FarmingTablet_directory.."huds/pfeilL.dds");
	self.overlay.pfeilR = createImageOverlay(FarmingTablet_directory.."huds/pfeilR.dds");
	self.overlay.error = createImageOverlay(FarmingTablet_directory.."huds/error.dds");
	self.overlay.AppSoilExtension = createImageOverlay(FarmingTablet_directory.."huds/Soil.dds");
	self.overlay.AppBank = createImageOverlay(FarmingTablet_directory.."huds_Bank/appBild.dds");
	self.overlay.fs = createImageOverlay(FarmingTablet_directory.."huds/FS.dds");
end;

function FarmingTablet:loadScripts ()
	source(FarmingTablet_directory.."Bank.lua");
	source(FarmingTablet_directory.."FabrikscriptExtension.lua");
	--source(FarmingTablet_directory.."SoilExtension.lua");
end;

function FarmingTablet:registerScripts ()
	FarmingTablet.scripts = {};
	FarmingTablet.scripts[0] = "Bank";
	FarmingTablet.scripts[1] = "FabrikscriptExtension";
	--FarmingTablet.scripts[2] = "SoilExtension";
	
	Bank:loadBank();
	FabrikscriptExtension:loadFabrikscriptExtension();
	--SoilExtension:loadSoilExtension();
end;

function FarmingTablet:update(dt)
	local dediready = g_currentMission:getIsServer() or g_currentMission.isMasterUser;
	if g_currentMission.clientPermissionSettings.ownMoney or dediready then
		dedi = true;
	else
		dedi = false;
	end;
	if g_currentMission.controlledVehicle == nil then
		if InputBinding.isPressed(InputBinding.FTopen1) then
			if InputBinding.hasEvent(InputBinding.FTopen2) then
				self:tapopen(true);		
								
			end;
		end;
	end;
	if g_currentMission.controlledVehicle == nil then	
		if InputBinding.isPressed(InputBinding.FTclose1) then
			if InputBinding.isPressed(InputBinding.FTclose2) then	
				self:tapclosed(true);
			end;
		end;
	end;
	if FarmingTablet.kz.app1 then 
		Bank:updateBank (dt);
	end;
	if FarmingTablet.kz.app2 then 
		FabrikscriptExtension:updateFabrikscriptExtension (dt);
	end;
	--if FarmingTablet.kz.app3 then
	--SoilExtension:updateSoilExtension (dt);
	--end;
	
	
end;

function FarmingTablet:tapopen (open)
	if open then
		g_currentMission.showHelpText = false;
		g_currentMission.isPlayerFrozen = true;
		g_currentMission.renderTime = false;
		g_currentMission.showVehicleSchema = false;
		g_currentMission.ingameMap.isVisible = false;
		g_currentMission.showHudEnv = false;
		g_currentMission.showWeatherForecast = false;
		InputBinding.setShowMouseCursor(true);
		self.hudOn = open;
	end;
end;

function FarmingTablet:tapclosed (closed)
	if closed then
		g_currentMission.showHelpText = true;
		g_currentMission.isPlayerFrozen = false;
		g_currentMission.renderTime = true;
		g_currentMission.showVehicleSchema = true;
		g_currentMission.ingameMap.isVisible = true;
		g_currentMission.showHudEnv = true;
		g_currentMission.showWeatherForecast = true;
		InputBinding.setShowMouseCursor(false);

		self.hudOn = false;
	end;
end;


function FarmingTablet:mouseEvent(posX, posY, isDown, isUp, button)
	if FarmingTablet.kz.app1 then
		Bank:StartscreenAppBank(posX, posY, isDown, button);
	end;
	if FarmingTablet.kz.app2 then
		FabrikscriptExtension:StartscreenAppFabrikscriptExtension(posX, posY, isDown, button);
	end;
	--if FarmingTablet.kz.app3 then
	--	SoilExtension:StartscreenApp(posX, posY, isDown, button);
	--end;
	if self.hudOn then
		
		if self.posDebug then
			print(posX .." " .. posY);
		end;
	end;	
	
	--App-Klickzonen--
	if posX > 0.149 and posX < 0.251 and posY >0.61 and posY < 0.81 and isDown and button == 1 and dedi and FarmingTablet.kz.app2 == false and FarmingTablet.kz.app3 == false  then
		FarmingTablet.kz.app1 = true;
	end;
	if posX > 0.3 and posX < 0.4 and posY >0.61 and posY < 0.81 and isDown and button == 1 and FarmingTablet.kz.app1 == false and FarmingTablet.kz.app3 == false then
		FarmingTablet.kz.app2 = true;
	end;
	--if posX > 0.45 and posX < 0.55 and posY >0.61 and posY < 0.81 and isDown and button == 1 and FarmingTablet.kz.app1 == false and FarmingTablet.kz.app2 == falsethen
	--	FarmingTablet.kz.app3 = true;
	--end;
	
	
	--if posX > 0.149 and posX < 0.251 and posY >0.61 and posY < 0.81 and isDown and button == 1 then
	--	FarmingTablet.kz.app2 = true;
	--end;
	--SoilExtension:StartscreenApp (posX, posY, isDown, button);
end;

function FarmingTablet:keyEvent(unicode, sym, modifier, isDown)
	--if FarmingTablet.kz.app3 then
	--	SoilExtension:keyEventSoilExtension(unicode, sym, modifier, isDown);
	--end;
end;


function FarmingTablet:draw()
	if self.hudOn then
		setTextColor(0, 0, 0, 1);
		renderOverlay(self.overlay.tablet, 0.01, 0.01, 1, 1.5);
		if self.start then --Apps auf Startbildschirm--
			renderOverlay(self.overlay.backScreen, 0.01, 0.01, 1, 1.5);
			renderOverlay(self.overlay.AppBank, 0.15, 0.6, 0.1, 0.2);
			renderOverlay(self.overlay.fs, 0.3, 0.6, 0.1, 0.2);
			--renderOverlay(self.overlay.AppSoilExtension, 0.45, 0.6, 0.1, 0.2);
			renderOverlay(self.overlay.error, 0.15, 0.6, 0.1, 0.2);
		end;
		
		if FarmingTablet.kz.app1 then
			Bank:drawBank();
			FarmingTablet.versuch = false;
		elseif dedi == false then
			renderText(0.141, 0.568, 0.025, tostring("Zugriff nur als Admin!"));
		end;
		if FarmingTablet.kz.app2 then
			FabrikscriptExtension:drawFabrikscriptExtension ();
		end;
		--if FarmingTablet.kz.app2 then
		--	SoilExtension:drawSoilExtension ();
		--end;
		
	end;
end;
function FarmingTablet:deleteMap()
	if self.hudOn then
		self.hudOn  = false;
	end;

end;
 
 function FarmingTablet:delete() end;
 
 
 
 
 
 
 